# Extraordinarily transparent compact metallic metamaterials
This repository contains the Julia codes used to generate and plot the figures of the paper 'Extraordinarily transparent compact metallic metamaterials'.

The data has already been generated and included in the repository. To regenerate the data, call `julia run_calculations.jl` from the `fdfd` or `fem` directories.

To plot the data, call `julia plotting.jl`.


## Requirements
* Julia (programming language)

### Julia packages
Install using the Julia package manager
* Conda.jl
* PyCall.jl
* PyPlot.jl
* JLD.jl
* LightGraphs.jl
* ProgressMeter.jl
* LorentzDrudeMetals.jl

### Python packages (called through Julia)
* meshio

To install meshio (used to read finite-element meshes generated by Gmsh) please run in the Julia REPL
```
using Conda
using PyCall
Conda.add("pip")
run(PyCall.python_cmd(`-m pip install meshio`)))
```

### Other software
We call the open-source program Gmsh from the command line to produce our finite-element meshes. Please ensure Gmsh is installed and added to your system path.
